<!--#include file="ayar.asp"-->
<%
Const MSG_THANKS= "OY KULLANDIINIZ N TEEKKR EDERZ"
Const MSG_DENIED= "BU SAYFA N OY KULLANMISINIZ"
Const MSG_NOVOTES= "BU SAYFA N OY KULLANILMAMI!"
Const MSG_RATING= "TOPLAM ([TOTALVOTES]) OY KULLANILMI."
Const STAR_WIDTH= 30
Const DEC_PLACES= 1
Const NEAREST_HALF= false


'--- Database connection string ----------------------------------------------
dim sConnectionString
'-----------------------------------------------------------------------------

'--- System DSN
'sConnectionString = "DSN=StarRatings"
'--- Microsoft Access 2000 (Absolute path)
'sConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Inetpub\wwwroot\uye\puan\asp_star_rating_v0.2/rating.mdb;"
'--- Microsoft Access 2000 (Virtual path)
sConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.MapPath(""&dbyolumuz&"") & ";"

'--- Blocked IP Ranges -------------------------------------------------------
'    Usage: AddBlockedIPRange LowerRange, UpperRange
'-----------------------------------------------------------------------------

AddBlockedIPRange "192.168.1.1", "192.168.1.10"

'--- Blocked User Agents -----------------------------------------------------
'    Prevent specific user agents from voting, this must be an EXACT match
'-----------------------------------------------------------------------------

AddBlockedUserAgent "Googlebot"'- Google
AddBlockedUserAgent "MSNBOT/0.1"'- MSN

'--- Blocked User Agent Strings ----------------------------------------------
'    Prevent user agents containing certain strings from voting
'-----------------------------------------------------------------------------

AddBlockedUAString "crawler"
AddBlockedUAString "spider"

'-----------------------------------------------------------------------------
'--- DO NOT TOUCH ANYTHING BELOW THIS LINE -----------------------------------
'-----------------------------------------------------------------------------

'--- Declarations
dim oRatingConn, rsRating
dim iURLID, iRatingAverage, iRatingWidth, iTotalRatings
dim sRatingURL, sUserIP, sMessage, sBannedIPRanges, sBlockedUserAgents, sBlockedUAStrings, sQueryString
dim bSuccess

'--- Functions & Subroutines
Sub RatingConnOpen
Set oRatingConn = Server.Createobject("ADODB.Connection")
oRatingConn.Open sConnectionString
End Sub
'---
Sub RatingConnClose
oRatingConn.Close
Set oRatingConn = Nothing
End Sub
'---
Function GetUserIP
if Request.ServerVariables("HTTP_X_FORWARDED_FOR") <> "" then
GetUserIP = Request.ServerVariables("HTTP_X_FORWARDED_FOR")
else
GetUserIP = Request.ServerVariables("REMOTE_ADDR")
end if
End Function
'---
Sub GetRating(m_sURL)
'--- Get rating
RatingConnOpen
Set rsRating = oRatingConn.Execute("select count(votes.Rating) as Total, avg(votes.Rating) as Average from rating_urls urls inner join rating_votes votes on votes.URLID = urls.ID where urls.URL='" & m_sURL & "'")
iRatingAverage= rsRating("Average")
iTotalRatings= rsRating("Total")
if IsNull(iRatingAverage) then
iRatingAverage = 0 '--- Prevents the next line trying to round a null value
else
if NEAREST_HALF = true then
iRatingAverage = NearestHalf(iRatingAverage)
else
iRatingAverage = round(iRatingAverage,DEC_PLACES)
end if
end if
iRatingWidth = round(iRatingAverage * STAR_WIDTH, 0)
Set rsRating = Nothing
RatingConnClose
End Sub
'---
Sub UpdateRating(iRating, m_sURL)
'--- Open URL table
RatingConnOpen
Set rsRating = Server.CreateObject("ADODB.Recordset")
rsRating.LockType = 2 'adLockPessimistic
rsRating.ActiveConnection = oRatingConn
rsRating.Source = "select ID, URL from rating_urls where URL='" & m_sURL & "'"
rsRating.Open
'--- Add URL if required
if rsRating.EOF then
rsRating.AddNew
rsRating("URL") = m_sURL
rsRating.Update
end if
'--- Get URL ID
iURLID = rsRating("ID")
rsRating.Close
Set rsRating = Nothing
'--- Add rating
Set rsRating = oRatingConn.Execute("select URLID from rating_votes where URLID=" & iURLID & " and UserIP='" & GetUserIP & "'")
if rsRating.EOF then
if not WithinBlockedRange(sBannedIPRanges, GetUserIP) and not BlockedUserAgent(sBlockedUserAgents) and not BlockedUserAgentString(sBlockedUAStrings) then oRatingConn.Execute("insert into rating_votes (URLID, Rating, UserIP) values (" & iURLID & ", " & iRating & ", '" & GetUserIP & "')")
bSuccess = true
else
bSuccess = false
end if
Set rsRating = Nothing
RatingConnClose
'--- Display if vote is unsuccessful (Javascript only)
if WithinBlockedRange(sBannedIPRanges, GetUserIP) then response.write "<p class=""starlight"">Blocked IP Address</p>"
if BlockedUserAgent(sBlockedUserAgents) then response.write "<p class=""starlight"">Blocked User Agent</p>"
if BlockedUserAgentString(sBlockedUAStrings) then response.write "<p class=""starlight"">Blocked User Agent String</p>"
End Sub
'---
Function IPtoDecimal(aIP)
aIP = Split(aIP, ".")
IPtoDecimal = (((Int(aIP(0)) * 256 + Int(aIP(1))) * 256) + Int(aIP(2))) * 256 + Int(aIP(3))
End Function
'---
Function HexToDecimal(sHex)
HexToDecimal = "" & CLng("&H" & sHex)
End Function
'---
Function DecimalToIP(iDecNum)
dim iDecNum1, iDecNum2, iDecNum3, iDecNum4
iDecNum = Hex(iDecNum)
iDecNum1 = HexToDecimal(Left(iDecNum,2))
iDecNum2 = HexToDecimal(Mid(iDecNum, 3, 2))
iDecNum3 = HexToDecimal(Mid(iDecNum, 5, 2))
iDecNum4 = HexToDecimal(Right(iDecNum,2))
iDecNum = iDecNum1 & "." & iDecNum2 & "." & iDecNum3 & "." & iDecNum4
DecimalToIP = iDecNum
End Function
'---
Function WithinBlockedRange(aBanRanges, sIPAddressIn)
dim m_sRange, m_aRange, m_iLower, m_iUpper, m_iIP, m_aBlockedRanges
'--- Remove trailing space from IP ranges and split multiple ranges
m_aBlockedRanges = Split(Trim(aBanRanges), " ")
'--- Get user IP as decimal
m_iIP = IPtoDecimal(sIPAddressIn)
'--- Loop through each range
for each m_sRange in m_aBlockedRanges
m_aRange= Split(m_sRange, "-")
m_iLower= IPtoDecimal(m_aRange(0))
m_iUpper= IPtoDecimal(m_aRange(1))
if int(m_iIP) => Int(m_iLower) and Int(m_iIP) =< Int(m_iUpper) then
WithinBlockedRange = true
exit for
end if
next
End Function
'---
Sub AddBlockedIPRange(sLowerIP, sUpperIP)
sBannedIPRanges = sBannedIPRanges & sLowerIP & "-" & sUpperIP & " "
End Sub
'---
Function BlockedUserAgent(aUserAgents)
dim m_sBadAgent, m_sUserAgent, m_aUserAgents
'--- Get user agent
m_sUserAgent = Request.ServerVariables("HTTP_USER_AGENT")
'--- Split user agents string
m_aUserAgents = aUserAgents
if Right(m_aUserAgents, 1) = "|" then m_aUserAgents = Left(m_aUserAgents, Len(m_aUserAgents) - 1)
m_aUserAgents = Split(aUserAgents, "|")
'--- Loop through user agents
for each m_sBadAgent in m_aUserAgents
if LCase(m_sBadAgent) = LCase(m_sUserAgent) then '- Case insensitive
BlockedUserAgent = true
exit for
end if
next
End Function
'---
Sub AddBlockedUserAgent(sBlockedAgent)
sBlockedUserAgents = sBlockedUserAgents & sBlockedAgent & "|"
End Sub
'---
Function BlockedUserAgentString(sBlockedStrings)
dim m_sBadString, m_sUserAgent, m_aStrings
'--- Get user agent
m_sUserAgent = Request.ServerVariables("HTTP_USER_AGENT")
'--- Split string
if Right(sBlockedStrings, 1) = "|" then sBlockedStrings = Left(sBlockedStrings, Len(sBlockedStrings) - 1)
m_aStrings = Split(sBlockedStrings, "|")
'--- Loop through disallowed strings
for each m_sBadString in m_aStrings
if InStr(LCase(m_sUserAgent), LCase(m_sBadString)) then '- Case sensitive
BlockedUserAgentString = true
exit for
end if
next
End Function
'---
Sub AddBlockedUAString(sBlockedString)
sBlockedUAStrings = sBlockedUAStrings & sBlockedString & "|"
End Sub
'---
Function NearestHalf(iNumberIn)
dim m_iNearestHalf
m_iNearestHalf = Round(iNumberIn * 2)
NearestHalf = m_iNearestHalf / 2
End Function
'---
Sub WriteListItems()
dim m_iLinks
response.write "<ul>" & vbcrlf & "puanlama sonucu <img src=images/puanlama/" & iRatingAverage & ".gif alt=puan durumu " & iRatingAverage & "> (" & iRatingAverage & ") <br>" & vbcrlf
for m_iLinks = 1 to 5
response.write "<a href=""" & QuerystringAppend(sRatingURL, "rating=" & m_iLinks) & "#star-rating"" onclick=""fAJAXRequest('star-rating','/" & RATING_DIR & "/rpc.asp?rating=" & m_iLinks & "&amp;url=" & Replace(sRatingURL, "&", "[=and=]") & "','nocache','',''); return false;"" title=""Rate this " & m_iLinks & " stars out of 5"" class=""star-" & m_iLinks & """>" & m_iLinks & "</a>  &nbsp;&nbsp;&nbsp;" & vbcrlf
next
response.write "</ul>" & vbcrlf & "<p>" & sMessage & "</p>" & vbcrlf
End Sub
'---
Function QuerystringAppend(m_sURL, m_sStringToAppend)
if InStr(m_sURL, "?") then
QuerystringAppend = m_sURL & "&" & m_sStringToAppend
else
QuerystringAppend = m_sURL & "?" & m_sStringToAppend
end if
End Function
'---
Function QuerystringRemove(m_sURL, m_sRemove)
'--- Private declarations
dim m_aURL, m_aKeys, m_sKey, m_sQS
if InStr(m_sURL, "?") then
'--- Get querystring
m_aURL= Split(m_sURL, "?")
m_sURL= m_aURL(0)
m_sQS= m_aURL(1)
'--- Get key/value pairs from querystring
m_aKeys= Split(m_sQS, "&")
m_sQS= ""
'--- Rebuild the querystring without the removed key/pair
for each m_sKey in m_aKeys
if Left(m_sKey, Len(m_sRemove) + 1) <> m_sRemove & "=" then m_sQS = m_sQS & m_sKey & "&"
next
'--- Trim the trailing ampersand
if Len(m_sQS) > 0 then
m_sQS = Left(m_sQS, Len(m_sQS) - 1)
QuerystringRemove = m_sURL & "?" & m_sQS
else '--- No keys left
QuerystringRemove = m_sURL
end if
'--- Return the URL with the rebuilt querystring
else
'--- Return the URL
QuerystringRemove = m_sURL
end if
End Function
'---
Function GetUserIP
if Request.ServerVariables("HTTP_X_FORWARDED_FOR") <> "" then
GetUserIP = Request.ServerVariables("HTTP_X_FORWARDED_FOR")
else
GetUserIP = Request.ServerVariables("REMOTE_ADDR")
end if
End Function
%>
<%
'--- Get server variables
sUserIP= GetUserIP
sRatingURL= Request.ServerVariables("URL")

'--- Appened querystring if required
sQueryString = Request.ServerVariables("QUERY_STRING")
if len(sQueryString) > 0 then
sRatingURL = sRatingURL & "?" & sQueryString
end if

'--- Add a rating (no Javascript)
if len(Request.QueryString("rating")) > 0 then
'--- Remove rating=i from URL
sRatingURL = QuerystringRemove(sRatingURL, "rating")
'--- Add rating
UpdateRating int(Request.QueryString("rating")), sRatingURL
'--- Append status to URL
if bSuccess then
sRatingURL = QuerystringAppend(sRatingURL, "rated=true")
else
sRatingURL = QuerystringAppend(sRatingURL, "rated=false")
end if
'--- Redirect
response.redirect sRatingURL
end if

'--- Remove rated=true/false before getting the page rating
sRatingURL = QuerystringRemove(sRatingURL, "rated")

'--- Get current rating
GetRating(sRatingURL)

'--- Display rating underneath stars
if iRatingAverage = 0 then
sMessage = MSG_NOVOTES
else
sMessage = replace(MSG_RATING, "[RATING]", iRatingAverage)
sMessage = replace(sMessage, "[TOTALVOTES]", iTotalRatings)
end if

'--- Display response text
if Request.QueryString("rated") = "true" then sMessage= sMessage & " <span class=""starlight"">" & MSG_THANKS & "</span>"
if Request.QueryString("rated") = "false" then sMessage = sMessage & " <span class=""starlight"">" & MSG_DENIED & "</span>"

'--- Display list
response.write "<div id=""star-rating"">" & vbcrlf
WriteListItems
response.write "</div>" & vbcrlf
%>